{PSTATE RESET 1.0 by Falcosoft}

program PSTATRES;
{$G+,N+,E-}

uses crt;

var
geax, gedx: longint;

procedure ReadMSR(var redx: longint; var reax: longint; recx: longint);
begin
 asm
 DB $66
 mov cx,word ptr [recx]
 DB $0F,$32 {rdmsr}
 les di,reax
 DB $66
 mov word ptr es:[di],ax
 les di,redx
 DB $66
 mov word ptr es:[di],dx
 end;
end;

procedure WriteMSR(redx, reax, recx : longint);
begin
  asm
  DB $66
  mov ax,word ptr [reax]
  DB $66
  mov dx,word ptr [redx]
  DB $66
  mov cx,word ptr [recx]
  DB $0F,$30 {wrmsr}
  end;
end;

begin
       { First Disable C1E since it increases power usage during hlt cycles
       and causes freezes when in P0 state}
       ReadMSR(gedx, geax, $C0010055);
       WriteMSR(gedx, geax and (not $10000000), $C0010055);

       begin
       { Write 0.5x multiplier (100 MHz) and default voltage for 800 MHz to 1st P-state register}
        WriteMSR($8000018B,$3E006500,$C0010064);

       {Fake P-state transition to apply new settings}
        WriteMSR(0,1,$C0010062);
        delay(10);
        WriteMSR(0,0,$C0010062);

       {Resets TSC to new clock speed}
        ReadMSR(gedx, geax, $C0010015);
        WriteMSR(gedx, geax and (not $01000000), $C0010015);
        WriteMSR(gedx, geax or $01000000, $C0010015);
       end;

end.

